Subject: Re: future developments of usbnet

From: Stephen Hemminger <[email-masked]>
Date: Mon, 9 May 2011 08:46:49 -0700

On Mon, 9 May 2011 11:31:16 -0400 (EDT)
Alan Stern <[email-masked]> wrote:

> On Mon, 9 May 2011, Ming Lei wrote:
> 
> > Hi,
> > 
> > 2011/5/9 Oliver Neukum <[email-masked]>:
> > 
> > > Do we really need to avoid it, or do we just need to recover?
> > > If avoidance is needed, should we use NAPI?
> > 
> > IMO, OOM can recover it certainly but with much cost, so we should
> > avoid the case. I don't think NAPI can avoid it, because NAPI will
> > cause skb to be allocated without any limit if there are packets
> > coming, still no chance left for usbnet_bh to handle and free these
> > SKBs.
> 
> How do other network drivers handle this problem?  Can the same 
> strategy be used?
> 
> Alan Stern

Most Ethernet drivers have a fixed size receive ring and pass preallocated
memory (skb's or pages) for the hardware to fill in. When NAPI poll is run
it refills the ring and passes the data up to netif_receive_skb. NAPI allows
the poll routine to process a limited number of packets (weight) and after
that the poll loop exits and gets rerun by soft interrupt.  If data is
arriving faster than the kernel can process, eventually the receive ring
passed to hardware gets exhausted and the hardware drops packets.

There is no explicit memory bound limit, instead the flow control happens
when the receive ring gets full.